#define _WINSOCK_DEPRECATED_NO_WARNINGS
#ifndef UNICODE
#define UNICODE
#endif

#define WIN32_LEAN_AND_MEAN

#include<string>
#include <winsock2.h>
#include <ws2tcpip.h>
#include <stdio.h>

// Need to link with Ws2_32.lib
#pragma comment(lib, "ws2_32.lib")

int wmain()
{

    //----------------------
    // Initialize Winsock
    WSADATA wsaData;
    int iResult = 0;

    int addrsize = sizeof(sockaddr_in);

    SOCKET ListenSocket = INVALID_SOCKET;
    sockaddr_in service;

    SOCKET RemoteClient1 = INVALID_SOCKET;;
    sockaddr_in client1;

#define MSGSIZE 256
    char szMessage[MSGSIZE];

    iResult = WSAStartup(MAKEWORD(2, 2), &wsaData);
    if (iResult != NO_ERROR) {
        wprintf(L"WSAStartup() failed with error: %d\n", iResult);
        return 1;
    }
    //----------------------
    // Create a SOCKET for listening for incoming connection requests.
    ListenSocket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
    if (ListenSocket == INVALID_SOCKET) {
        wprintf(L"socket function failed with error: %ld\n", WSAGetLastError());
        WSACleanup();
        return 1;
    }
    //----------------------
    // The sockaddr_in structure specifies the address family,
    // IP address, and port for the socket that is being bound.
    service.sin_family = AF_INET;
    service.sin_addr.s_addr = inet_addr("127.0.0.1");
    service.sin_port = htons(20792);

    iResult = bind(ListenSocket, (SOCKADDR*)&service, sizeof(service));
    if (iResult == SOCKET_ERROR) {
        wprintf(L"bind function failed with error %d\n", WSAGetLastError());
        iResult = closesocket(ListenSocket);
        if (iResult == SOCKET_ERROR)
            wprintf(L"closesocket function failed with error %d\n", WSAGetLastError());
        WSACleanup();
        return 1;
    }
    //----------------------
    // Listen for incoming connection requests 
    // on the created socket
    if (listen(ListenSocket, SOMAXCONN) == SOCKET_ERROR)
        wprintf(L"listen function failed with error: %d\n", WSAGetLastError());

    wprintf(L"Listening on socket...\n");

    RemoteClient1 = accept(ListenSocket, (struct sockaddr*)&client1, &addrsize);
    printf("Accepted client:%s:%d\n", inet_ntoa(client1.sin_addr),
        ntohs(client1.sin_port));

    while (1)
    {
        RemoteClient1 = accept(ListenSocket, (struct sockaddr*)&client1, &addrsize);
        printf("Accepted client:%s:%d\n", inet_ntoa(client1.sin_addr),
            ntohs(client1.sin_port));
        
        auto ret = recv(RemoteClient1, szMessage, EMSGSIZE, 0);
        szMessage[ret] = '\0';
        printf("Received [%d bytes]: '%s'\n", ret, szMessage);

        std::string s = "OK";
        memcpy(szMessage, s.c_str(), s.length());
        szMessage[strlen(szMessage)] = '\0';
        send(RemoteClient1, szMessage, strlen(szMessage) + 1, 0);
    }

    iResult = closesocket(RemoteClient1);
    if (iResult == SOCKET_ERROR) {
        wprintf(L"closesocket function failed with error %d\n", WSAGetLastError());
        WSACleanup();
        return 1;
    }

    iResult = closesocket(ListenSocket);
    if (iResult == SOCKET_ERROR) {
        wprintf(L"closesocket function failed with error %d\n", WSAGetLastError());
        WSACleanup();
        return 1;
    }

    WSACleanup();
    return 0;
}
